﻿#PK_OM_LIST    = 0
#PK_OM_EXTRACT = 1

#PK_SKIP       = 0
#PK_TEST       = 1
#PK_EXTRACT    = 2

; Import "ICLRead.wcx"
; OpenArchive(*ArchiveData);
; EndImport

	Structure OPENARCHIVEDATAAW
		oadArcNameAW.l
		oadOpenMode.l
		oadOpenResult.l
		oadCmtBufAW.l
		oadCmtBufSize.l
		oadCmtSize.l
		oadCmtState.l
	EndStructure;OPENARCHIVEDATAAW ends
	
Structure HEADERDATA
		hdArcName.s{260};         db 260 dup(?)
		hdFileName.s{260};        db 260 dup(?)
		hdFlags.l
		hdPackSize.l
		hdUnpSize.l
		hdHostOS.l
		hdFileCRC.l
		hdFileTime.l
		hdUnpVer.l
		hdMethod.l
		hdFileAttr.l
		hdCmtBuf.l
		hdCmtBufSize.l
		hdCmtSize.l
		hdCmtState.l
	EndStructure;HEADERDATA ends
	
		Structure HEADERDATAEXW
		hdArcNameW.s{1024};        dw 1024 dup(?)
		hdFileNameW.s{1024};       dw 1024 dup(?)
		hdFlags.l
		hdPackSizeLow.l
		hdPackSizeHigh.l
		hdUnpSizeLow.l
		hdUnpSizeHigh.l
		hdHostOS.l
		hdFileCRC.l
		hdFileTime.l
		hdUnpVer.l
		hdMethod.l
		hdFileAttr.l
		hdCmtBuf.l
		hdCmtBufSize.l
		hdCmtSize.l
		hdCmtState.l
		hdReserved.s{1024};        db 1024 dup(?)
	EndStructure        ;HEADERDATAEXW ends
	
	libHandle=LoadLibrary_("ICLRead.wcx")
	
	If libHandle
	  
	  *OpenArchive=GetProcAddress_(libHandle,?fn1);"OpenArchiveW")
	  *ReadHeader=GetProcAddress_(libHandle,?fn2);"ReadHeaderExW")
	  *ProcessFileW=GetProcAddress_(libHandle,?fn3);"ProcessFileW")
	  ;*SetProcessDataProc=GetProcAddress_(libHandle,"SetProcessDataProc")
	  *CloseArchive=GetProcAddress_(libHandle,?fn4);"CloseArchive")

    archiveDataAW.OPENARCHIVEDATAAW
    
  archiveDataAW\oadOpenMode=#PK_OM_LIST
	archiveDataAW\oadCmtBufAW=0
	archiveDataAW\oadCmtBufSize=0
	archiveDataAW\oadCmtSize=0
	archiveDataAW\oadCmtState=0
	ap.s="d:\wcx\Hardware_.icl"
	archiveDataAW\oadArcNameAW=@ap
	
	archiveHandle=CallFunctionFast(*OpenArchive,@archiveDataAW)
	
	headerDataAW.HEADERDATAEXW
;	tmpb.s=Space(1024)
	If archiveHandle
	Repeat
	  rr=CallFunctionFast(*ReadHeader,archiveHandle,@headerDataAW)
	  f$=headerDataAW\hdFileNameW
	  ;ProcessFile (HANDLE hArcData, int Operation, char *DestPath, char *DestName);
	  CallFunctionFast(*ProcessFileW,archiveHandle,#PK_SKIP,0,0)
	  ds.s=GetCurrentDirectory()+"tmp\"+f$
	CallFunctionFast(*ProcessFileW,archiveHandle,#PK_EXTRACT,0,@ds);works if folder 'tmp' exists

Until rr
CallFunctionFast(*CloseArchive,archiveHandle)
EndIf

	  FreeLibrary_(libHandle)
	EndIf
	
	DataSection
	  fn1:
	  Data.a $4F,$70,$65,$6E,$41,$72,$63,$68,$69,$76,$65,$57,0,0
	  fn2:
	  Data.a 82,101,97,100,72,101,97,100,101,114,69,120,87,0
	  fn3:;ProcessFileW
	  Data.a 80,114,111,99,101,115,115,70,105,108,101,87,0
	  fn4:;CloseArchive
	  Data.a 67,108,111,115,101,65,114,99,104,105,118,101,0

	  
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 91
; FirstLine = 68
; EnableUnicode
; EnableXP
; Executable = zupa.exe